/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-16 19:40
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============

vector<int> prefix_function(string s){
  vector<int> p(size(s));
  for (int i = 1; i < ssize(s); i++) {
    int j = p[i - 1];
    while (j > 0 && s[i] != s[j])
      j = p[j - 1];
    p[i] = j + (s[i] == s[j]);
  }
  return p;
}

const int MAXA = 256;
vector<vector<int>> pa_build(string s) {
  vector<int> p = prefix_function(s += "$");
  vector<vector<int>> pa(size(s), vector<int>(MAXA));
  for (int i = 0; i < ssize(s); i++)
    for (char c = 'a'; c <= 'z'; c++)
      if (i > 0 && c != s[i])
        pa[i][c] = pa[p[i - 1]][c];
      else
        pa[i][c] = i + (c == s[i]);
  return pa;
}

vector<int> res;

void pa_search(string t, vector<vector<int>> &pa) {
  /* vector<int> ans; */
  for (int i = 0, j = 0; i < ssize(t); i++) {
    j = pa[j][t[i]];
    cerr << j << endl;
    res[i] = j;
    
    /* if (j == ssize(pa) - 1) */
    /*   ans.push_back(i - ssize(pa) + 2); */
  }
  /* return ans; */
}


void solve(){
    // Code goes here ...
    string s, word;
    ll M, N;
    cin >> s >> M;
    N = ssize(s);

    R(i,M){
        cin >> word;
        auto a = pa_build(word);
        res.assign(N + ssize(word), -1);
        
        pa_search(s, a);

        for(auto e: res)
            cerr << e << " ";
        cerr << endl;


    }

}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
